import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;

import javax.swing.event.*;
/**
 * represente la visualisation graphique des tags du document 
 */
public class ListeTagIhm extends JScrollPane
{
/**
 * la fenetre mere
 */
protected MainFrame _master;
/**
 * la liste graphique 
 */
protected JList _liste;
/**
 * la liste des tag
 */
protected ListeTag _tag;
protected BaliseNode [] _bnode;
/**
 * constructeur de la classe , on passe la fenetre mere en parametre
 */
public ListeTagIhm(MainFrame master)
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
setSize(600, 400);
_master=master;
_liste=new JList();
getViewport().setView(_liste);
setVisible(true);
}
/**
 * mets a jour le composant avec une liste de tag
 */
public void SetTag(ListeTag tag,String document)
{
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag);
_bnode=xmlnode.getNode();

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {String affiche=new String();

 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getFin()-work.getTag().getDebut();
 	if (taille>20) taille=20;
 	/* TODO verifier la taille max */
 	
 	affiche=affiche+(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	
 	}
	else
	{
	decal=decal-2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	
}
test.add(affiche);
 }
_liste=new JList(test);
getViewport().setView(_liste);
setVisible(true);

MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
     try{  
             int index = _liste.locationToIndex(e.getPoint());
             Tag t;
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
             System.out.println("Double clicked on Item " + index);
             ListeTagIhm.this._master.select(t);
             ListeTagIhm.this._master.viewLigne(t.getLigne());
     } catch (Exception ve) {System.out.println(ve);}; 
     }
 };
 _liste.addMouseListener(mouseListener);
 
repaint();
}/*
public void SetTag(String document,ListeTag tag, String dtdfile)
{
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag);
_bnode=xmlnode.getNode();

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {String affiche=new String();

 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getDebut()-work.getTag().getFin();
 	if (taille>20) taille=20;
 	affiche=affiche+document.substring(work.getTag().getDebut(),taille);
 	}
	else
	{
	decal=decal-2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	
}
test.add(affiche);
 }
_liste=new JList(test);
getViewport().setView(_liste);
setVisible(true);

MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
     try{  
             int index = _liste.locationToIndex(e.getPoint());
             Tag t;
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
             System.out.println("Double clicked on Item " + index);
             ListeTagIhm.this._master.select(t);
             ListeTagIhm.this._master.viewLigne(t.getLigne());
     } catch (Exception ve) {System.out.println(ve);}; 
     }
 };
 _liste.addMouseListener(mouseListener);
 
repaint();
}*/
public void select (Tag t)
{
for (int i=0;i<_bnode.length;i++)
{
if (_bnode[i].getTag().equals(t)) {_liste.setSelectedIndex(i);
int max_ligne=_liste.getLastVisibleIndex();
JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nvalue=(i*max)/max_ligne;
  
  _scroll.setValue(nvalue);
return;}
}        
}

}
