import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
/** 
 * PreferenceDialog permet de choisir les attribut graphiques
*/ 
public class PreferenceDialog extends JDialog
{

 
  protected MutableAttributeSet m_attributes;
  
  protected JComboBox m_cbColorDefaultXML;
  protected JCheckBox m_chkBoldDefaultXML;
  protected JCheckBox m_chkItalicDefaultXML;
  protected JCheckBox m_chkUnderlineDefaultXML;
  protected OpenList m_lstFontNameDefaultXML;
  
  
  protected JComboBox m_cbColorDefaultText;
  protected JCheckBox m_chkBoldDefaultText;
  protected JCheckBox m_chkItalicDefaultText;
  protected JCheckBox m_chkUnderlineDefaultText;
  protected OpenList m_lstFontNameDefaultText;
  
  protected OpenList m_lstFontNameTreeViewText;
  protected OpenList m_lstFontNameTreeViewXML;
 
  protected int m_option = JOptionPane.CLOSED_OPTION;
 
  protected MainFrame _master;
  public PreferenceDialog(MainFrame master, 
    String[] names)
   
   {
   _master=master;
     getContentPane().setLayout(new BoxLayout(getContentPane(), 
      BoxLayout.Y_AXIS));
     JPanel ppp=new JPanel(new GridLayout(2, 1, 10, 2));
  
    JPanel pp=new JPanel(new GridLayout(1, 2, 10, 2));
    JPanel p = new JPanel(new GridLayout(2, 1, 10, 2));
    p.setBorder(new TitledBorder(new EtchedBorder(), "Modify Balise Default Style"));
    m_lstFontNameDefaultXML = new OpenList(names, "Font Name:");
    p.add(m_lstFontNameDefaultXML); 
     JPanel p2 = new JPanel(new GridLayout(3, 1, 10, 5));
    p2.setBorder(new TitledBorder(new EtchedBorder(), "Default Balise Xml Property"));
    m_chkBoldDefaultXML = new JCheckBox("Bold");
    p2.add(m_chkBoldDefaultXML);
    m_chkItalicDefaultXML = new JCheckBox("Italic");
    p2.add(m_chkItalicDefaultXML);
    m_chkUnderlineDefaultXML = new JCheckBox("Underline");
    p2.add(m_chkUnderlineDefaultXML);
    p.add(p2);
pp.add(p);

  
    p = new JPanel(new GridLayout(2, 1, 10, 2));
    p.setBorder(new TitledBorder(new EtchedBorder(), "Modify Text Style"));
    m_lstFontNameDefaultText = new OpenList(names, "Font Name:");
    p.add(m_lstFontNameDefaultText); 
    
    p2 = new JPanel(new GridLayout(3, 1, 10, 5));
    p2.setBorder(new TitledBorder(new EtchedBorder(), "Default Text Property"));
    m_chkBoldDefaultText = new JCheckBox("Bold");
    p2.add(m_chkBoldDefaultText);
    m_chkItalicDefaultText = new JCheckBox("Italic");
    p2.add(m_chkItalicDefaultText);
    m_chkUnderlineDefaultText = new JCheckBox("Underline");
    p2.add(m_chkUnderlineDefaultText);
    p.add(p2);
    pp.add(p);
    
JPanel p1 = new JPanel(new GridLayout(1, 2, 10, 2));
    JButton btOK = new JButton("OK");
    ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.OK_OPTION;
        _master.setPreference(getAttributesDefaultXML());
        setVisible(false);
      }
    };
    btOK.addActionListener(lst);
    p1.add(btOK);

    JButton btCancel = new JButton("Cancel");
    lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.CANCEL_OPTION;
        setVisible(false);
      }
    };
    btCancel.addActionListener(lst);
    p1.add(btCancel);
    ppp.add(pp);
    ppp.add(p1);
    pack();
        getContentPane().add(ppp);
        pack();
}
 public SimpleAttributeSet getAttributesDefaultXML() {
    /*if (m_attributes == null)
      return null;*/
      SimpleAttributeSet result=new SimpleAttributeSet();
    StyleConstants.setFontFamily(result, 
      m_lstFontNameDefaultXML.getSelected());
    
    StyleConstants.setBold(result, 
      m_chkBoldDefaultXML.isSelected());
    StyleConstants.setItalic(result, 
      m_chkItalicDefaultXML.isSelected());
    StyleConstants.setUnderline(result, 
      m_chkUnderlineDefaultXML.isSelected());
   
    return result;
  }
}
  